#!/bin/sh

# perform a two-pass rsync backup of production PostgreSQL host
# to backup host

# remote (production) host IP
REMOTE=<masked>

# database cluster path
CLUSTER=<masked>

# log path
LOGDIR=<masked>

# stop local (backup) backend
pg_ctl -D $CLUSTER stop -m smart

# sync remote data cluster to local (first pass)
rsync -avz --delete --exclude='*.conf' $REMOTE:$CLUSTER $CLUSTER

# sync remote wal to local (first pass)
rsync -avz --delete $REMOTE:$LOGDIR $LOGDIR

# stop remote (production) backend
ssh $REMOTE pg_ctl -D $CLUSTER stop -m smart

# sync remote data cluster to local (second pass)
rsync -avz --delete --exclude='*.conf' $REMOTE:$CLUSTER $CLUSTER

# sync remote wal to local (first pass)
rsync -avz --delete $REMOTE:$LOGDIR $LOGDIR

# restart remote (production) backend
ssh $REMOTE pg_ctl -D $CLUSTER start

# restart local (backup) backend
pg_ctl -D $CLUSTER start

# fin


